"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ArgumentValidationError_1 = require("../ArgumentValidationError");
function formatArgumentValidationError(err) {
    const formattedError = {};
    formattedError.message = err.message;
    formattedError.locations = err.locations;
    formattedError.path = err.path;
    if (err.originalError instanceof ArgumentValidationError_1.ArgumentValidationError) {
        formattedError.validationErrors = err.originalError.validationErrors;
    }
    return formattedError;
}
exports.formatArgumentValidationError = formatArgumentValidationError;
