"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs_1 = require("fs");
const graphql_1 = require("graphql");
const path = require("path");
exports.defaultSchemaFilePath = path.resolve(process.cwd(), "schema.gql");
const generatedSchemaWarning = /* graphql */ `\
# -----------------------------------------------
# !!! THIS FILE WAS GENERATED BY TYPE-GRAPHQL !!!
# !!!   DO NOT MODIFY THIS FILE BY YOURSELF   !!!
# -----------------------------------------------

`;
function emitSchemaDefinitionFileSync(schemaFilePath, schema, options = { commentDescriptions: true }) {
    const schemaFileContent = generatedSchemaWarning + graphql_1.printSchema(schema, options);
    fs_1.writeFileSync(schemaFilePath, schemaFileContent);
}
exports.emitSchemaDefinitionFileSync = emitSchemaDefinitionFileSync;
function emitSchemaDefinitionFile(schemaFilePath, schema, options = { commentDescriptions: true }) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const schemaFileContent = generatedSchemaWarning + graphql_1.printSchema(schema, options);
        return new Promise((resolve, reject) => fs_1.writeFile(schemaFilePath, schemaFileContent, err => (err ? reject(err) : resolve())));
    });
}
exports.emitSchemaDefinitionFile = emitSchemaDefinitionFile;
